/*
drop table GRHUM.REST_REQUETE cascade constraints;
drop table GRHUM.REST_REQUETE_LOCAL cascade constraints;

drop sequence GRHUM.REST_REQUETE_SEQ;
drop sequence GRHUM.REST_REQUETE_LOCAL_SEQ;
*/

CREATE TABLE GRHUM.REST_REQUETE (    
   ID_REST_REQUETE NUMBER(38,0) NOT NULL, 
   STR_ID VARCHAR2(1000) NOT null,
   LIBELLE VARCHAR2(255) NOT NULL,
   CATEGORIE VARCHAR2(1000) NOT NULL,
   COMMENTAIRE_DEVELOPPEUR VARCHAR2(4000) NULL,
   COMMENTAIRE_UTILISATEUR VARCHAR2(4000) NULL,
   SQL_REQ clob NOT NULL
);


CREATE UNIQUE INDEX GRHUM.PK_REST_REQUETE ON GRHUM.REST_REQUETE(ID_REST_REQUETE) LOGGING TABLESPACE INDX_GRHUM;
ALTER TABLE GRHUM.REST_REQUETE ADD ( CONSTRAINT PK_REST_REQUETE  PRIMARY KEY (ID_REST_REQUETE) USING INDEX GRHUM.PK_REST_REQUETE);
alter TABLE GRHUM.REST_REQUETE ADD CONSTRAINT UNIQ_REST_REQUETE UNIQUE (STR_ID);

COMMENT ON TABLE GRHUM.REST_REQUETE IS 'Les requetes utilisees par les services REST (ces requetes ne doivent pas etre modifiees : utilisez la table GRHUM.REST_REQUETE_LOCAL pour crééer des nouvelles requetes ou surcharger celles-ci)';
COMMENT ON COLUMN GRHUM.REST_REQUETE.ID_REST_REQUETE IS 'Cle';    
COMMENT ON COLUMN GRHUM.REST_REQUETE.STR_ID IS 'Identifiant signifiant de la requete';    
COMMENT ON COLUMN GRHUM.REST_REQUETE.LIBELLE IS 'Libellé de la requete';    
COMMENT ON COLUMN GRHUM.REST_REQUETE.CATEGORIE IS 'Categorie de la requete';    
COMMENT ON COLUMN GRHUM.REST_REQUETE.COMMENTAIRE_DEVELOPPEUR IS 'Description de la requete a destination du developpeur du client du service REST';    
COMMENT ON COLUMN GRHUM.REST_REQUETE.COMMENTAIRE_UTILISATEUR IS 'Description de la requete a destination de l''utilisateur final de la requete';    
COMMENT ON COLUMN GRHUM.REST_REQUETE.SQL_REQ IS 'Requete sql';    


CREATE TABLE GRHUM.REST_REQUETE_LOCAL (    
   ID_REST_REQUETE_LOCAL NUMBER(38,0) NOT NULL, 
   STR_ID VARCHAR2(1000) NOT null,
   LIBELLE VARCHAR2(255) NOT NULL,
   CATEGORIE VARCHAR2(1000) NOT NULL,
   COMMENTAIRE_DEVELOPPEUR VARCHAR2(4000) NULL,
   COMMENTAIRE_UTILISATEUR VARCHAR2(4000) NULL,
   SQL_REQ clob NOT NULL
);


CREATE UNIQUE INDEX GRHUM.PK_REST_REQUETE_LOCAL ON GRHUM.REST_REQUETE_LOCAL(ID_REST_REQUETE_LOCAL) LOGGING TABLESPACE INDX_GRHUM;
ALTER TABLE GRHUM.REST_REQUETE_LOCAL ADD ( CONSTRAINT PK_REST_REQUETE_LOCAL  PRIMARY KEY (ID_REST_REQUETE_LOCAL) USING INDEX GRHUM.PK_REST_REQUETE_LOCAL);
alter TABLE GRHUM.REST_REQUETE_LOCAL ADD CONSTRAINT UNIQ_REST_REQUETE_LOCAL UNIQUE (STR_ID);

COMMENT ON TABLE GRHUM.REST_REQUETE_LOCAL IS 'Les requetes utilisees par les services REST (ces requetes sont propres à votre environnement et seront prioritaires sur les requetes de la table GRHUM.REST_REQUETE)';
COMMENT ON COLUMN GRHUM.REST_REQUETE_LOCAL.ID_REST_REQUETE_LOCAL IS 'Cle';    
COMMENT ON COLUMN GRHUM.REST_REQUETE_LOCAL.STR_ID IS 'Identifiant signifiant de la requete';    
COMMENT ON COLUMN GRHUM.REST_REQUETE_LOCAL.LIBELLE IS 'Libellé de la requete';    
COMMENT ON COLUMN GRHUM.REST_REQUETE_LOCAL.CATEGORIE IS 'Categorie de la requete';    
COMMENT ON COLUMN GRHUM.REST_REQUETE_LOCAL.COMMENTAIRE_DEVELOPPEUR IS 'Description de la requete a destination du developpeur du client du service REST';    
COMMENT ON COLUMN GRHUM.REST_REQUETE_LOCAL.COMMENTAIRE_UTILISATEUR IS 'Description de la requete a destination de l''utilisateur final de la requete';   
COMMENT ON COLUMN GRHUM.REST_REQUETE_LOCAL.SQL_REQ IS 'Requete sql';    



ALTER INDEX GRHUM.UNIQ_REST_REQUETE REBUILD TABLESPACE INDX_GRHUM;
ALTER INDEX GRHUM.UNIQ_REST_REQUETE_LOCAL REBUILD TABLESPACE INDX_GRHUM;
alter table GRHUM.REST_REQUETE move lob (SQL_REQ) store as lobsegment (tablespace INDX_GRHUM);
alter table GRHUM.REST_REQUETE_LOCAL move lob (SQL_REQ) store as lobsegment3 (tablespace INDX_GRHUM);



CREATE SEQUENCE GRHUM.REST_REQUETE_SEQ START WITH 1 MAXVALUE 999999999999999999999999999 MINVALUE 1 NOCYCLE NOCACHE NOORDER;
CREATE SEQUENCE GRHUM.REST_REQUETE_LOCAL_SEQ START WITH 1 MAXVALUE 999999999999999999999999999 MINVALUE 1 NOCYCLE NOCACHE NOORDER;

----

create or replace force view jefy_admin.v_etab_for_organ (org_id, org_id_etab)
as
  select     org_id,
              to_number (replace (sys_connect_by_path (decode (level, 1, org_id), '~'), '~')) as org_id_etab
   from       jefy_admin.organ
   where      level > 0
   start with org_niv = 1
   connect by prior org_id = org_pere;
   
   